#include <stdbool.h>
#include <wchar.h>

typedef wchar_t wstring [MAXLEN];

struct abr {
    struct abr* gauche; 
    wchar_t clef;
    wchar_t satellite;
    struct abr* droit;
};

#define NIL (struct abr*)0


extern struct abr* ajout_abr_rec (wchar_t, wchar_t , struct abr*);

/* Calcule la hauteur d'un abr*/
extern int hauteur_abr( struct abr*);

extern bool recherche_abr_rec (int, struct abr*);

extern void imprime_abr (struct abr*);

extern void imprime_abrV2 (struct abr*);

extern void clear_abr (struct abr*);
