// abr.h

#include <stdbool.h>

struct abr {
    struct abr* gauche; // ne contient que des entiers < valeur
    int valeur;
    struct abr* droit;  // ne contient que des entiers > valeur
};

#define NIL (struct abr*)0

extern struct abr* ajout_abr_iter (int, struct abr*);

extern struct abr* ajout_abr_rec (int, struct abr*);

extern bool recherche_abr_iter (int, struct abr*);

extern bool recherche_abr_rec (int, struct abr*);

extern void imprime_abr (struct abr*);

extern void clear_abr (struct abr*);


