#if ! defined (LISTE_CHAR_H)
#define LISTE_CHAR_H 1

struct maillon_char
{   char value;
    struct maillon_char* next;
};

struct liste_char
{   struct maillon_char* tete;
    int nbchar;
};

#define NIL (struct maillon_char*)0

/* 
 * Constructeur 
 * Initialise son paramètre à la liste vide 
 */
extern void init_liste_char (struct liste_char*);

/* 
 * Destructeur 
 */
extern void clear_liste_char (struct liste_char*);

/* 
 * Ajout d'un char en entête de liste 
 */
extern void ajouter_en_tete_liste_char (struct liste_char*, char);


/* 
 * Ajout d'un char en queue de liste 
 */
extern void ajouter_en_queue_liste_char (struct liste_char*, char);


/* 
 * Affecte à *d la valeur du premier élément de L et supprime cet élément de L. 
 * La liste L est supposée non vide.
 */
extern void extraire_tete_liste_char (char* d, struct liste_char* L);

/* 
 * Impression. 
 */
extern void imprimer_liste_char (struct liste_char*);

/* 
 * Copie liste dst -> source
 */
extern void set_liste_char
        (struct liste_char* dst, struct liste_char* src);

#endif
